"""

"""


class ItemImage:
    def __init__(self):
        pass


class ItemProperty:
    def __init__(self):
        pass


class Item:
    """
    @type remote_id:    str
    @type price:        float
    @type currency      str
    @type warranty      int, None
    @type stock         int, None
    @type name          string
    """
    def __init__(self, remote_id, remote_category=None, remote_description=None,
                 price=None, currency=None, warranty=None, stock=None,
                 name=None, brand=None, series=None, model=None, modification=None, release=None,
                 gtin14=None, gtin13=None, gtin8=None, mpn=None,
                 images=None, properties=None, description=None, article=None,
                 parent=None):
        self.remote_id = str(remote_id)
        self.price = price
        self.currency = currency
        self.warranty = warranty
        self.stock = stock
        self.name = name
        self.brand = brand
        self.series = series
        self.model = model
        self.modification = modification
        self.release = release
        self.gtin14 = gtin14
        self.gtin13 = gtin13
        self.gtin8 = gtin8
        self.mpn = mpn
        self.images = images
        self.properties = properties
        self.description = description
        self.article = article
        self.parent = parent
        self.remote_category = remote_category
        self.remote_description = remote_description

    def __str__(self):
        return "Item(%s)" % self.__dict__


class Parser:
    def __init__(self, source, **kwargs):
        self.source = source
        self.kwargs = kwargs

    def int(self, value, default=None):
        try:
            return int(value)
        except ValueError:
            return default

    def float(self, value, default=None):
        try:
            return float(value)
        except ValueError:
            return default

    def str(self, value):
        if isinstance(value, unicode):
            return value.encode("utf8")
        else:
            return str(value)

    def on_start(self):
        """

        """
        pass

    def on_except(self, ex):
        """

        """
        pass

    def on_complete(self):
        """

        """
        pass

    def parse(self):
        """
        Implementation

        @rtype:     generator
        @return:    Parsed item
        """
        pass